<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>Form work1</title>
  <script>
    /*
      Задание:
        Сделать шиблонизатор элемента по:
        Ширине input type=range
        Цвету  input type=color
        Высоте input type=number
        Скругление углов input type=number
        Внутрение отступы input type=number

      Свойсвта: https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Properties_Reference

      Бонус:
        + Сделать выборку цвета из статичных цветов которые выбираются из появившегося блока :
        https://s3.envato.com/files/230412754/screenshots/1.png


    */
    window.addEventListener("load", function () {
      var myWidth = document.getElementById('myWidth');
      var myHeight = document.getElementById('myHeight');
      var layout = document.getElementById('lout');
      // Ваш код тут.
      myWidth.addEventListener('input', function(event){
        result.style.width = event.target.value + 'px';
      });
      // myColor.addEventListener('input', function(e){
      //   result.style.background = e.target.value;
      // })
      var myColorListener = myColor.addEventListener('click', function(e){
        for (var i = 1; i <= 20; i++) {
          var colorElement = document.createElement('div');
          colorElement.className = 'child';
          colorElement.style.backgroundColor = getRandomColor(getRandomIntInclusive(0, 257), getRandomIntInclusive(0, 257), getRandomIntInclusive(0, 257));
          colorElement.addEventListener('click', function(e) {
            // var target = e.target;
            var x = layout.querySelectorAll('.child');
            x.forEach( function( item ){
              item.classList.remove('activeChild');
            })
            result.style.background = e.target.style.backgroundColor;
            e.target.classList.add('activeChild');
            console.log(colorElement.style.backgroundColor);
          })
          console.log(colorElement);
          layout.appendChild(colorElement);
          removeEventListener('click', myColorListener);
        }
      })
      myHeight.addEventListener('input', function(e) {
        result.style.height = e.target.value + 'px';
      })
      myBorderRadius.addEventListener('input', function(e) {
        result.style.borderRadius = e.target.value + 'px';
      })
      myPadding.addEventListener('input', function(e) {
        result.style.padding = e.target.value + 'px';
      })

      function getRandomIntInclusive(min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        return Math.floor(Math.random() * (max - min + 1)) + min;
      }

      function getRandomColor(r, g, b) {
        console.log(r, g, b);
        return 'rgb(' + r + ',' + g + ',' + b + ')';
      }
    });
  </script>
</head>
<body>
  <div class="Templating">
    <header>
      <input type="range" id="myWidth" min="10" max="500" step="10"/>
      <input type="range" id="myHeight" min="10" max="500" step="10"/>
      <input type="range" id="myBorderRadius" min="10" max="500" step="1"/>
      <input type="range" id="myPadding" min="10" max="500" step="10"/>
      <input type="button" id="myColor" value="Change Color" min="10" max="500" step="10"/>
    
    </header>

    <div class="TemplatingResult">
      <div id="result" class="result"></div>
      <div class="wrapper">
        <div class="layout" id="lout"></div>
      </div>
    </div>
  </div>

  <style>
    .result{
      width: 50px;
      background: gray;
      box-sizing: border-box;
      padding: 10px;
      float: left;
    }
    
    #MyValidateForm{
      width: 350px;
      display: flex;
      flex-direction: column;
    }

    #MyValidateForm input{
      margin-bottom: 10px;
      /*box-sizing: border-box;*/
      padding: 10px 20px;
    }

    .wrapper {
      max-width: 30%;
    }
    
    .activeChild{
      background-image: url(./correct-symbol.png);
      background-repeat: no-repeat;
      background-position: center center;
    }

    .layout {
      display: grid;
      /* grid-template-columns: 1fr 1fr 1fr; */
      /* // same as: */
      grid-template-columns: repeat(5, 1fr);
      grid-gap: 8px;
    }

    .child {
      min-height: 100px;
      min-width: 100px;
      /*background: orange;*/
      line-height: 100px;
      text-align: center;
      border-radius: 50px;
    }
  </style>
</body>
</html>
